<template>
  <div>
    <AtomAlert
      v-if="fetchError"
      class="fr-mb-2w"
      :alert-type="AlertType.Error"
      :message="fetchError"
    />
    <AtomLoader
      v-else-if="pending"
      class="fr-mx-auto fr-mb-2w"
    />
    <AtomFilters
      v-else
      :filters="filters"
      :initial-selected-values="INITIAL_VALUES"
      @filter="onFilter"
    />
  </div>
</template>

<script setup>
  import {
    agentToAgentOption,
    formatDate,
    parseKindOfBoolean,
    toOptions,
    withEmptyValue
  } from '~/utils'
  import { FilterType } from '~/utils/constants/filters'
  import { TYPE_SUIVI_OPTIONS } from '~/utils/constants/history'
  import { HELP_REQUEST_STATUS_OPTIONS } from '~/utils/constants/help-requests'
  import {
    INTERVIEW_STATUS_OPTIONS,
    INTERVIEW_TYPE_OPTIONS
  } from '~/utils/constants/interview'
  import { usePermissionsStore } from '~/store/permissions'
  import { AlertType } from '~~/utils/constants/alert'
  import { getRandomId } from '~~/utils/random'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { useFiltersStore } from '~/store/filters'

  const HANDLING_DATE_NAME = 'handling_date'
  const STATUS_NAME = 'status'
  const FOLLOW_UP_TYPE_NAME = 'follow_up_type'
  const EXTERNAL_ORGANISATION = 'external_organisation'

  const { $loadAgents, $loadOrganisationFollowUpTypes, $getItems } =
    useNuxtApp()
  const permissionsStore = usePermissionsStore()
  const filtersStore = useFiltersStore()
  const INITIAL_VALUES = getInitialValues()

  const props = defineProps({
    isInInterviewsContext: { type: Boolean, required: true },
    isInHelpRequestsContext: { type: Boolean, required: true }
  })

  const emit = defineEmits(['filter'])

  const historyType = computed(() => {
    if (props.isInInterviewsContext) return 'interviews'
    if (props.isInHelpRequestsContext) return 'help_requests'
    return ''
  })

  /**
   * NOTE: As BeneficiaryHistoryFilters are used both in InterviewsTable and
   * HelpRequestsTable that are in the same page, the two following asyncData are
   * done simultaneous while fetching the same data. If they use the same
   * async data key, the latter to start falls in an infinte pending state.
   */
  const {
    data: agentOptions,
    pending: agentOptionsPending,
    error: agentOptionsError
  } = useLazyAsyncData(`agentOptions-${historyType.value}`, loadAgents, {
    server: false
  })

  const {
    data: followUpTypeOptions,
    pending: followUpTypeOptionsPending,
    error: followUpTypeOptionsError
  } = useLazyAsyncData(
    `followUpTypeOptions-${historyType.value}`,
    loadFollowUpTypeOptions,
    {
      server: false
    }
  )

  const {
    data: examinationDateOptions,
    pending: examinationDateOptionsPending,
    error: examinationDateOptionsError
  } = useLazyAsyncData(
    getRandomId('examinationDateOptions'),
    loadExaminationDateOptions,
    { server: false }
  )

  const pending = computed(
    () =>
      agentOptionsPending.value ||
      followUpTypeOptionsPending.value ||
      examinationDateOptionsPending.value
  )

  const fetchError = computed(() => {
    if (agentOptionsError.value) {
      return "La liste des agents n'a pas pu être chargée."
    }
    if (followUpTypeOptionsError.value) {
      return "La liste des types d'accompagnement n'a pas pu être chargée."
    }
    if (examinationDateOptionsError.value) {
      return "La liste des dates de passage en commission n'a pas pu être chargée."
    }
    return ''
  })

  const canAccessRestrictedFieldsInHelpRequest = computed(
    () => permissionsStore.canAccessRestrictedFieldsInHelpRequest
  )

  const statusOptions = computed(() => {
    if (props.isInInterviewsContext && props.isInHelpRequestsContext) {
      return new Map([
        ...INTERVIEW_STATUS_OPTIONS.entries(),
        ...HELP_REQUEST_STATUS_OPTIONS.entries()
      ])
    }
    return props.isInInterviewsContext
      ? INTERVIEW_STATUS_OPTIONS
      : HELP_REQUEST_STATUS_OPTIONS
  })

  const filters = computed(() => {
    const _filters = [
      {
        name: STATUS_NAME,
        label: 'Statut',
        options: withEmptyValue(statusOptions.value, 'Tous les statuts'),
        type: FilterType.SelectOne,
        isInterviewFilter: props.isInInterviewsContext,
        isHelpRequestFilter: props.isInHelpRequestsContext
      }
    ]
    if (props.isInInterviewsContext && props.isInHelpRequestsContext) {
      _filters.push({
        name: 'type_suivi',
        label: 'Type de suivi',
        options: withEmptyValue(TYPE_SUIVI_OPTIONS, 'Tous les suivis'),
        type: FilterType.SelectOne,
        isInterviewFilter: false,
        isHelpRequestFilter: false
      })
    }
    if (props.isInInterviewsContext) {
      _filters.push({
        name: 'type',
        label: "Type d'entretien",
        options: INTERVIEW_TYPE_OPTIONS,
        type: FilterType.SelectMultiple,
        isInterviewFilter: true,
        isHelpRequestFilter: false
      })
    }
    if (followUpTypeOptions.value) {
      const followUpTypeLabel =
        props.isInInterviewsContext && !props.isInHelpRequestsContext
          ? "Objet de l'entretien"
          : props.isInHelpRequestsContext && !props.isInInterviewsContext
          ? 'Objet de la demande'
          : "Type d'accompagnement"
      _filters.push({
        name: FOLLOW_UP_TYPE_NAME,
        label: followUpTypeLabel,
        options: followUpTypeOptions.value,
        type: FilterType.SelectMultiple,
        isInterviewFilter: true,
        isHelpRequestFilter: true
      })
    }
    if (
      props.isInHelpRequestsContext &&
      canAccessRestrictedFieldsInHelpRequest.value &&
      examinationDateOptions.value
    ) {
      _filters.push({
        name: 'examination_date',
        label: 'Date de passage en commission',
        options: withEmptyValue(
          examinationDateOptions.value,
          'Toutes les commissions'
        ),
        type: FilterType.SelectOne,
        isInterviewFilter: false,
        isHelpRequestFilter: true
      })
    }
    if (
      props.isInHelpRequestsContext &&
      canAccessRestrictedFieldsInHelpRequest.value
    ) {
      _filters.push(
        {
          name: HANDLING_DATE_NAME,
          label: 'Fin de prise en charge',
          options: new Map([
            ['', 'Non sélectionné'],
            ['true', 'Oui'],
            ['false', 'Non']
          ]),
          type: FilterType.SelectOne,
          isInterviewFilter: false,
          isHelpRequestFilter: true
        },
        {
          name: EXTERNAL_ORGANISATION,
          label: 'Instruction',
          options: new Map([
            ['', 'Toutes les instructions'],
            ['false', 'Interne'],
            ['true', 'Organisme externe']
          ]),
          type: FilterType.SelectOne,
          isInterviewFilter: false,
          isHelpRequestFilter: true
        }
      )
    }
    if (agentOptions.value) {
      _filters.push({
        name: 'user_created',
        label: 'Référent',
        options: agentOptions.value,
        type: FilterType.SelectMultiple,
        isInterviewFilter: true,
        isHelpRequestFilter: true
      })
    }

    return _filters
  })

  async function loadAgents() {
    const agents = await $loadAgents()
    return new Map(agents.map(agentToAgentOption))
  }

  async function loadFollowUpTypeOptions() {
    const followUpTypes = await $loadOrganisationFollowUpTypes()
    return toOptions(followUpTypes, 'id', 'name')
  }

  async function loadExaminationDateOptions() {
    if (
      !props.isInHelpRequestsContext ||
      !canAccessRestrictedFieldsInHelpRequest.value
    ) {
      return
    }
    const examniationDates = await loadExaminationDates()
    return dateToDateOptions(examniationDates)
  }

  async function loadExaminationDates() {
    const res = await $getItems('help_requests', {
      fields: ['examination_date'],
      filter: { examination_date: { _nnull: true } }
    })

    if (res.status === 200) return getUniqueDates(res.data.data)
    throw new Error(errorResponseMessage(res))
  }

  function getUniqueDates(helpRequests) {
    return Array.from(new Set(helpRequests.map(b => b.examination_date)))
  }

  function dateToDateOptions(dates) {
    return new Map(dates.map(d => [d, formatDate(d)]))
  }

  function onFilter(formData) {
    if (!formData) {
      emit('filter', {
        interviewFilters: null,
        helpRequestFilters: null
      })
      return
    }

    const selectedFilters = {
      interviewFilters: prepareFilters(formData, true, false),
      helpRequestFilters: prepareFilters(formData, false, true),
      typeSuivi: formData.type_suivi
    }

    const filtersToSave = {
      directusQuery: selectedFilters,
      selectedFilters: formData
    }

    if (props.isInInterviewsContext && !props.isInHelpRequestsContext) {
      filtersStore.interviewHistory = filtersToSave
    } else if (props.isInHelpRequestsContext && !props.isInInterviewsContext) {
      filtersStore.helpRequestHistory = filtersToSave
    } else {
      filtersStore.beneficiaryHistory = filtersToSave
    }
    emit('filter', selectedFilters)
  }

  function prepareFilters(
    formData,
    isInInterviewsContext,
    isInHelpRequestsContext
  ) {
    if (
      (isInInterviewsContext && isInHelpRequestsContext) ||
      (!isInInterviewsContext && !isInHelpRequestsContext)
    ) {
      throw new Error(
        'History filters must be prepared either for interviews or for help requests'
      )
    }
    return Object.entries(formData).reduce((preparedFilters, [name, value]) => {
      if (value) {
        const filter = filters.value.find(f => f.name === name)

        if (
          (filter.isInterviewFilter && isInInterviewsContext) ||
          (filter.isHelpRequestFilter && isInHelpRequestsContext)
        ) {
          if (name === HANDLING_DATE_NAME) {
            if (parseKindOfBoolean(value)) {
              preparedFilters[name] = { _nnull: true }
            } else preparedFilters[name] = { _null: true }
          } else if (name === STATUS_NAME) {
            const isInterviewStatus = INTERVIEW_STATUS_OPTIONS.has(value)
            if (
              (isInInterviewsContext && isInterviewStatus) ||
              (isInHelpRequestsContext && !isInterviewStatus)
            ) {
              preparedFilters[name] = { _eq: value }
            }
          } else if (name === FOLLOW_UP_TYPE_NAME) {
            if (isInInterviewsContext) {
              preparedFilters.follow_up_types = {
                follow_up_types_id: { _in: value }
              }
            } else preparedFilters.follow_up_type = { _in: value }
          } else if (filter.type === FilterType.SelectMultiple) {
            preparedFilters[name] = { _in: value }
          } else preparedFilters[name] = { _eq: value }
        }
      }
      return preparedFilters
    }, {})
  }

  function getInitialValues() {
    let savedFilters
    if (props.isInInterviewsContext && !props.isInHelpRequestsContext) {
      savedFilters = filtersStore.interviewHistory.selectedFilters
    } else if (props.isInHelpRequestsContext && !props.isInInterviewsContext) {
      savedFilters = filtersStore.helpRequestHistory.selectedFilters
    } else {
      savedFilters = filtersStore.beneficiaryHistory.selectedFilters
    }
    return savedFilters || {}
  }
</script>
